;---     8048 -----

 .EQU RGL, #031H; Saved L
 .EQU RGH, #032H; Saved H
 .EQU KEY, #033H; Key pressed

; reset vector
 .org  0
start:
  dis   i ; disable interrupts
  jmp  main

; external interrupt vector
 .org  3
intr:
  jmp  intr   ;

; timer interrupt vector
 .org  7
time:
  jmp  time   ;

main:
  DIS  TCNTI    ; turn off counter
  ANL  P1,#00H  ; 0111.1111b

  MOV  R0,RGL
  MOV  A,#0ACH
  MOV  @R0,A
  INC  R0
  MOV  A,#5EH
  MOV  @R0,A
  INC  R0
  MOV  A,#00H
  MOV  @R0,A

MAIN_LOOP:
;  CALL DELAY100; R5,R6
MA1:
   JT0  MA2     ; T0 NOT Pressed
   MOV  R0,KEY  ;
   MOV  A,@R0
   JNZ  MA3
   MOV  A,#0FFH
   MOV  @R0,A
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   CALL NOIZE
   JMP  MA3
MA2:
   CLR  A
   MOV  @R0,A
MA3:
   JMP  MAIN_LOOP

NOIZE:
   MOV  R2,#0C0H ;  192
L39:
   CALL GEN
   ADD  A,#80H   ; CPI  80H
   JNC  L3A      ; A >= 80H
   ORL  P1,#80H  ; 1000.0000b
L3A:
   DEC  R2
   CALL GEN
   ADD  A,#81H   ; CPI  7FH
   JNC  L3B      ; A >= 7FH
   ANL  P1,#7FH  ; 0111.1111b
L3B:
   DJNZ R2,L39
   ANL  P1,#7FH  ; 0111.1111b
   RET
GEN:
   MOV  R0,RGH   ; ->RGH
   MOV  A,@R0    ; A = H
   ANL  A,#0C0H  ; 1100.0000b
   MOV  R3,A
   ADD  A,R3     ; RAL ?
   XRL  A,R3
   ANL  A,#80H   ; Test Bit7
   JZ   GE2
   DEC  R0       ; ->RGL
   MOV  A,@R0    ; A = L
   INC  A
   MOV  R3,A
   ADD  A,R3     ; L = 2xL
   MOV  @R0,A    ; Save L
   INC  R0       ; ->RGH
   MOV  A,@R0    ; A = H
   MOV  R3,A
   ADDC A,R3     ; H = 2xH+C
   MOV  @R0,A    ; Save H
   RET
GE2:
   DEC  R0       ; ->RGL
   MOV  A,@R0    ; A = L
   MOV  R3,A
   ADD  A,R3     ; L = 2xL
   MOV  @R0,A    ; Save L
   INC  R0       ; ->RGH
   MOV  A,@R0    ; A = H
   MOV  R3,A
   ADDC A,R3     ; H = 2xH+C
   MOV  @R0,A    ; Save H
   RET

;---------------- R5,R6
DELAY100:
   MOV  R6,#84
LOOPEX:
   MOV  R5,#236
LOOPIN:
   DJNZ R5,LOOPIN
   DJNZ R6,LOOPEX
   MOV  R6,#4
LOOPAD:
   DJNZ R6,LOOPAD
   RET